require "miniauth/version"
require "bcrypt"

class Miniauth
  attr_reader :email

  def initialize(params)
    @params = params
    @email  = params[:email]
    @errors = []
  end

  def valid?(params)
    @errors << "Email is not valid." unless @params[:email] =~ /\A([^@\s]+)@((?:[-a-z0-9]+\.)+[a-z]{2,})\Z/i
    @errors << "Email is blank." if @params[:email].blank?
    @errors << "Password is blank." if @params[:password].blank?
    @errors.empty?       
  end

  def authenticate(user)
    user && BCrypt::Password.new(user[:password]) == @params[:password]
  end

  def encrypted_password
    @encrypted_password ||= BCrypt::Password.create(@params[:password])
  end

  def generate_token
    SecureRandom.hex(64)
  end
end